using Bp.Sync.BackEnd.Infrastructure.ElasticDbContext;
using Bp.Sync.Domain.Elastics.Inventories;
using Bp.Sync.Dto.Results;
using Bp.Sync.Dto.SmartTable;
using Microsoft.Extensions.Options;
using Nest;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace Bp.Sync.BackEnd.Infrastructure.Repositories
{
    public interface IProductInvoiceRepository
    {
        Task<BaseResult> Add(ProductInvoiceElastic ProductInvoice);
        Task<BaseResult> AddManyAsync(IEnumerable<ProductInvoiceElastic> ProductInvoices);
        Task<SmartTableResult<ProductInvoiceElastic>> Search(BoolQueryDescriptor<ProductInvoiceElastic> query);
        Task<SmartTableResult<ProductInvoiceElastic>> Search(BoolQueryDescriptor<ProductInvoiceElastic> query, int count);

    }
    public class ProductInvoiceRepository : IProductInvoiceRepository
    {
        private readonly ElasticIndex<ProductInvoiceElastic> _dbContext;

        public ProductInvoiceRepository(IOptions<ElasticConnectionSettings> settings)
        {
            _dbContext = new ElasticIndex<ProductInvoiceElastic>(settings.Value.ClusterUrl, "inventoryproductinvoice");
        }


        public async Task<SmartTableResult<ProductInvoiceElastic>> Search(BoolQueryDescriptor<ProductInvoiceElastic> query, int count)
        {
            return await _dbContext.Search(query, count);
        }
         public async Task<SmartTableResult<ProductInvoiceElastic>> Search(BoolQueryDescriptor<ProductInvoiceElastic> query)
        {
            return await _dbContext.Search(query);
        }


        public async Task<BaseResult> Add(ProductInvoiceElastic ProductInvoice)
        {
            var result = new BaseResult() { Result = Dto.Results.Result.Success };
            var rs = await _dbContext.Insert(ProductInvoice);
            if (rs.IsValid)
            {
                result.Result = Dto.Results.Result.Success;
            }
            else
            {
                result.Result = Dto.Results.Result.SystemError;
                result.Message = "Không tạo được bản ghi";
            }
            return result;
        }
        public async Task<BaseResult> AddManyAsync(IEnumerable<ProductInvoiceElastic> ProductInvoices)
        {
            var result = new BaseResult { Result = Dto.Results.Result.Success };
            try
            {
                var rs = await _dbContext.InsertMany(ProductInvoices);
                if (rs.IsValid) return result;
                else
                {
                    result.Result = Dto.Results.Result.Failed;
                    result.Message = rs.Errors.ToString();
                    return result;
                }
            }
            catch (Exception exx)
            {
                result.Result = Dto.Results.Result.Failed;
                result.Message = exx.Message.ToString();
                return result;
            }
        }

    }
}
